#include "testlib.h"

#include <iostream>
#include <string>
#include <set>

using namespace std;

const int MAXN = 100000;
const int MAXQ = 200000;
const int MAXLEN = 200000;


int main(int argc, char *argv[]) {
	registerValidation(argc, argv);

	int n = inf.readInt(1, MAXN, "n");
	inf.readEoln();
	int sumlen = 0;
	for (int i = 0; i < n; ++i) {
		string s = inf.readToken("[a-z]{1,1000000}","s");
		inf.readEoln();
		sumlen += s.length();
		ensuref(sumlen <= MAXLEN, "ERROR: too big total length of strings ...");
	
	}

	int q = inf.readInt(1, MAXQ, "q");
	inf.readEoln();
	for (int i = 0; i < q; ++i) {
		inf.readInt(1, n, "num_i");
		inf.readSpace();
		inf.readInt(1, n, "k_i");
		inf.readEoln();
	}

	inf.readEof();
	return 0;
}