// ConnectForTwo.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

//#include "pch.h"
#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <utility>
#include <set>
#include <map>
#include <memory.h>

using namespace std;

const int MAXNUM = 1 << 17;
const int MAXLEN = 1 << 18;

int n;
int bor[MAXLEN][26];
int borsz = 1;
int isEnd[MAXLEN], sz[MAXLEN], hs[MAXLEN], nextv[MAXLEN];
string ss[MAXNUM];

void insertToBor(const string &s) {
	int v = 0;
	++sz[0];
	for (char c : s) {
		int &nv = bor[v][c - 'a'];
		if (nv == 0) {
			nv = borsz++;
			hs[nv] = hs[v] + 1;
		}
		v = nv;
		++sz[nv];
	}
	isEnd[v]++;
}

void solve() {
	int num;
	long long k;
	cin >> num >> k;
	--num;
	string& s = ss[num];
	long long ans = n;
	ans = min(ans, k * s.length());
	for (int v = bor[0][s[0]-'a']; hs[v] < (int)s.length(); ) {
		ans = min(ans, k * (hs[v] - 1) + sz[v]);
		if (nextv[v] == v)
			v = bor[v][s[hs[v]] - 'a'];
		else
			v = nextv[v];
	}

	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> ss[i];
		insertToBor(ss[i]);
	}

	for (int v = borsz - 1; v >= 0; --v) {
		nextv[v] = v;
		if (isEnd[v])
			continue;
		int pos = -1;
		int kol = 0;
		for (int i = 0; i < 26; ++i)
			if (bor[v][i]) {
				pos = i;
				++kol;
			}
		if (kol >= 2)
			continue;
		nextv[v] = nextv[bor[v][pos]];
	}

	int q;
	cin >> q;
	while (q--)
		solve();

	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
