#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
    #define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
    #define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using D = double;
using uint = unsigned int;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

const int N = 200200;
map<char, int> go[N];
int here[N];
int cnt[N];
int vForWord[N];
char s[N];
int ans[N];
vector<pii> Q[N];
int n, m, q;
vector<pii> a;

int getAns(int k) {
	/*
	eprintf("getAns %d\n", k);
	for (pii t : a)
		eprintf("(%d %d) ", t.first, t.second);
	eprintf("\n");
	*/
	int res = 0;
	int pos = 1, w = k;
	for (pii t : a) {
		int x = t.second, pp = t.first;
		int z = min(x, w);
		res += z;
		x -= z;
		w -= z;
		if (x > 0) {
			pos++;
			w = k;
			if (pos <= pp) {
				z = min(x / k, pp - pos);
				res += z * k;
				pos += z;
				x -= k * z;
				z = min(x, w);
				res += z;
				x -= z;
				w -= z;
			}
		}
	}
	return res;
}

void solve(int v, int h) {
	if (!Q[v].empty()) {
		if (cnt[v] != 0) a.push_back(mp(h, cnt[v]));
		for (pii t : Q[v]) {
			ans[t.second] = getAns(t.first);
		}
		if (cnt[v] != 0) a.pop_back();
	}
	for (auto e : go[v]) {
		int u = e.second;
		if (h > 0 && cnt[v] != cnt[u]) a.push_back(mp(h, cnt[v] - cnt[u]));
		solve(u, h + 1);
		if (h > 0 && cnt[v] != cnt[u]) a.pop_back();
	}
}

int main()
{
	m = 1;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf("%s", s);
		int len = strlen(s);
		int v = 0;
		for (int j = 0; j < len; j++) {
			char c = s[j];
			if (go[v].count(c) == 0)
				go[v][c] = m++;
			v = go[v][c];
		}
		vForWord[i] = v;
		cnt[v]++;
	}
	for (int i = m - 1; i >= 0; i--) {
//		cnt[i] = min(cnt[i], 1);
		for (auto e : go[i])
			cnt[i] += cnt[e.second];
	}
	scanf("%d", &q);
	for (int i = 0; i < q; i++)
	{
		int id, k;
		scanf("%d%d", &id, &k);
		id--;
		Q[vForWord[id]].pb({k, i});
	}
	solve(0, 0);
	for (int i = 0; i < q; i++) printf("%d\n", ans[i]);
    return 0;
}
