#include <iostream>
#include <vector>
#include <set>
#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);

	int p = atoi(argv[1]);
	int t = atoi(argv[2]);
	int m = atoi(argv[3]);

	vector <pair <int, int> > lst;
	
	if ((long long)p * t <= m * 10) {
		for (int i = 1; i <= p; ++i) {
			for (int j = 1; j <= t; ++j) {
				lst.push_back({i, j});
			}
		}
	} else {
		vector <set <int> > gr(p);
		for (int i = 0; i < m; ++i) {
			while (true) {
				int u = rnd.next(p);
				int v = rnd.next(t);
				if (gr[u].find(v) == gr[u].end()) {
					gr[u].insert(v);
					lst.push_back({u + 1, v + 1});
					break;
				}
			}
		}
	}
	shuffle(lst.begin(), lst.end());
	
	cout << p << " " << t << " " << m << "\n";
	for (int i = 0; i < m; ++i) {
		cout << lst[i].first << " " << lst[i].second << "\n";
	}
}