#include "testlib.h"

#include <cstring>
#include <iostream>
#include <utility>
#include <vector>
#include <set>

using namespace std;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	
	int X, Y, n;
	sscanf(argv[1], "%d", &X);
	sscanf(argv[2], "%d", &Y);
	sscanf(argv[3], "%d", &n);
	
	int x, y, r, h;
	sscanf(argv[4], "%d", &x);
	sscanf(argv[5], "%d", &y);
	sscanf(argv[6], "%d", &r);
	sscanf(argv[7], "%d", &h);

	cout << X << ' ' << Y << ' ' << n << '\n' << x << ' ' << y << '\n';
	vector<pair<int, int> > ps;
	for (int i = 0; i <= X; ++i) {
		if (i < x - r || x + r < i)
			continue;

		int ddy = floor(sqrt((long long)r*r - (long long)(x - i) * (x - i)));
		for (int vvv = 0, dy = -ddy; vvv <= 1; ++vvv, dy += 2 * ddy)
			for (int yy = max(0, y + dy - h); yy <= min(Y, y + dy + h); ++yy)
				if (i != x || y != y)
				    ps.push_back(make_pair(i, yy));
	}
	sort(ps.begin(), ps.end());
	ps.resize(unique(ps.begin(), ps.end()) - ps.begin());
	shuffle(ps.begin(), ps.end());
	for (int i = 0; i < min((int)ps.size(), n-1); ++i)
		cout << ps[i].first << ' ' << ps[i].second << "\n";
	return 0;
}