#include "testlib.h"

#include <iostream>
#include <string>
#include <set>

using namespace std;

const int MAXCOORD = 200000;
const int MAXN = 200000;


int main(int argc, char *argv[]) {
	registerValidation(argc, argv);

	int X, Y, n;
	X = inf.readInt(1, MAXCOORD, "X");	
	inf.readSpace();
	Y = inf.readInt(1, MAXCOORD, "X");
	inf.readSpace();
	n = inf.readInt(1, MAXCOORD, "K");
	inf.readEoln();

	set<pair<int, int> > S;
	for (int i = 0; i < n; ++i) {
		int x, y;
		x = inf.readInt(0, X, "x_i");
		inf.readSpace();
		y = inf.readInt(0, Y, "y_i");
		inf.readEoln();
		S.insert(make_pair(x, y));
	}
	inf.readEof();
	ensuref(S.size() == n, "ERROR: there are at least two equal points...");
	return 0;
}