#include <iostream>
#include <vector>
#include <string>
#include <cassert>
#include "testlib.h"

using namespace std;

int n, m;
vector <vector <char> > room;
vector <pair <int, int> > cells;

void f() {
    auto p = cells[rnd.next((int)cells.size())];
    cout << p.first + 1 << " " << p.second + 1 << endl;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    n = atoi(argv[1]);
    m = atoi(argv[2]);

    int a = atoi(argv[3]);
    int b = atoi(argv[4]);
    int c = atoi(argv[5]);

    room.assign(n, vector <char> (m, 'W'));

    for (int i = 1; i + 1 < n; ++i) {
        for (int j = 1; j + 1 < m; ++j) {
            int r = rnd.next(a + b + c);
            if (r < a) {
                room[i][j] = '.';
                cells.push_back({i, j});
            } else {
                if (r < a + b) {
                    room[i][j] = 'G';
                } else {
                    room[i][j] = 'W';
                }
            }
        }
    }
    assert(cells.size() > 0);

    cout << n << " " << m << endl;
    for (auto &v: room) {
        for (auto &c: v) {
            cout << c;
        }
        cout << endl;
    }
    f();
    f();

    return 0;
}