#include "testlib.h"

#include <cstring>
#include <iostream>
#include <utility>
#include <vector>
#include <set>
#include <cstdio>

using namespace std;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	
	int len, n, sym, q, kl, kr;
	sscanf(argv[1], "%d", &len);	
	sscanf(argv[2], "%d", &n);
	sscanf(argv[3], "%d", &sym);
	sscanf(argv[4], "%d", &q);
	sscanf(argv[5], "%d", &kl);
	sscanf(argv[6], "%d", &kr);


	vector<char> cs;
	for (int i = 0; i < 26; ++i)
		cs.push_back('a' + i);
	shuffle(cs.begin(), cs.end());
	cs.resize(sym);

	vector<int> a(len - n, 0);
	for (int i = 0; i < n - 1; ++i)
		a.push_back(1);
	shuffle(a.begin(), a.end());
	a.push_back(1);
	vector<string> ss;
	string s = "";
	for (int v : a) {
	    s.push_back(cs[rnd.next(sym)]);
	    if (v == 1) {
			ss.push_back(s);
			s = "";
		}
	}
		

	cout << n << "\n";
	for (const string &s : ss)
		cout << s << "\n";
	cout << q << "\n";
	for (int i = 0; i < q; ++i)
	    {
		 int qq1,qq2;
		 qq1=rnd.next(1,n);
		 qq2=rnd.next(kl,kr);
		cout << qq1 << ' ' << qq2 << "\n";
	    }
	return 0;
}