#include "testlib.h"

#include <cstring>
#include <iostream>
#include <utility>
#include <vector>
#include <set>
#include <cstdio>

using namespace std;

string genRandomString(int len) {
	string s = "";
	for (int i = 0; i < len; ++i) {
		s.push_back('a' + rnd.next(26));
	}
	return s;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	
	int len, n, lenc, mid, h, sht, q;
	
	sscanf(argv[1], "%d", &len);	
	sscanf(argv[2], "%d", &n);
	sscanf(argv[3], "%d", &lenc);
	sscanf(argv[4], "%d", &mid);
	sscanf(argv[5], "%d", &h);
	sscanf(argv[6], "%d", &sht);
	sscanf(argv[7], "%d", &q);

	int sum = 0;
	string smain = genRandomString(lenc);
	sum += lenc;
	vector<string> ss(1, smain);

	int l = mid - ((n - 1) / 2) * h;
	for (int i = 1; i < n; ++i) {
		int nl = l + rnd.next(-sht, sht);
		nl = max(nl, 1);
		nl = min(nl, lenc);
		string s = smain.substr(0, nl);
		ss.push_back(s);
		sum += nl;
		l += h;
	}

	for (; sum < len; ++sum) {
		ss[rnd.next(0, n - 1)].push_back('a' + rnd.next(0, 25));
	}

	vector<pair<int, int> > qs;
	for (int i = 0; i < n; ++i)
		for (int j = 1; j <= n && j <= (int)ss[i].length(); ++j)
			qs.push_back(make_pair(i, j));
	while (qs.size() < q)
		qs.push_back(make_pair(rnd.next(0, n - 1), rnd.next(1, n)));

	cout << n << "\n";
	for (int i = 0; i < n; ++i)
		cout << ss[i] << "\n";
	cout << q << "\n";
	for (int i = 0; i < q; ++i) {
		cout << qs[i].first + 1 << ' ' << qs[i].second << "\n";
	}
	return 0;
}