#include <iostream>
#include <vector>
#include <set>
#include <assert.h>
#include "testlib.h"

using namespace std;

void geni(vector <int> &v) {
	for (int i = 0; i < v.size(); ++i) {
		v[i] = i + 1;
	}
	shuffle(v.begin(), v.end());
}

int main(int argc, char *argv[]) {
	registerGen(argc, argv, 1);

	int p = atoi(argv[1]);
	int t = atoi(argv[2]);
	int m = atoi(argv[3]);
	int p0 = atoi(argv[4]);
	int t0 = atoi(argv[5]);
	assert(m >= (long long)p0 * t);
	assert((long long)p0 * t0 + (long long)p * (t - t0) >= m);

	vector <int> pv(p), tv(t);
	geni(pv);
	geni(tv);

	vector <pair <int, int> > ans;
	vector <set <int> > gr(p + 1);
	for (int i = 0; i < p0; ++i) {
		for (int j = 0; j < t0; ++j) {
			ans.push_back({pv[i], tv[j]});
			gr[pv[i]].insert(tv[j]);
		}
	}

	for (int j = t0; j < t; ++j) {
		if (p0 * 10 >= p) {
			shuffle(pv.begin(), pv.end());
			for (int i = 0; i < p0; ++i) {
				ans.push_back({pv[i], tv[j]});
				gr[pv[i]].insert(tv[j]);
			}
		} else {
			for (int i = 0; i < p0; ++i) {
				while (true) {
					int u = rnd.next(p) + 1;
					if (gr[u].find(tv[j]) == gr[u].end()) {
						gr[u].insert(tv[j]);
						ans.push_back({u, tv[j]});
						break;
					}
				}
			}
		}
	}

	vector <pair <int, int> > lst;
	if ((long long)p * (t - t0) <= 10 * m) {
		for (int i = 1; i <= p; ++i) {
			for (int j = t0; j < t; ++j) {
				if (gr[i].find(tv[j]) == gr[i].end()) {
					lst.push_back({i, tv[j]});
					gr[i].insert(tv[j]);
				}
			}
		}
	} else {
		for (int i = ans.size(); i < m; ++i) {
			while (true) {
				int u = rnd.next(p) + 1;
				int v = rnd.next(t0, t - 1);
				if (gr[u].find(tv[v]) == gr[u].end()) {
					gr[u].insert(tv[v]);
					lst.push_back({u, tv[v]});
					break;
				}
			} 
		}
	}

	shuffle(lst.begin(), lst.end());

	for (int i = ans.size(); i < m; ++i) {
		ans.push_back(lst.back());
		lst.pop_back();
	}

	shuffle(ans.begin(), ans.end());
	
	cout << p << " " << t << " " << m << "\n";
	for (int i = 0; i < m; ++i) {
		cout << ans[i].first << " " << ans[i].second << "\n";
	}
}