#include <iostream>
#include <set>
#include <vector>
#include "testlib.h"

using namespace std;

const int MAXN = 1e5;
const int MAXM = 1e6;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    int p = inf.readInt(1, MAXN, "p");
    inf.readSpace();
    int t = inf.readInt(1, MAXN, "t");
    inf.readSpace();
    int m = inf.readInt(0, MAXM, "m");
    inf.readEoln();

    vector <set <int> > gr(p);
    for (int i = 0; i < m; ++i) {
    	int u = inf.readInt(1, p, "u") - 1;
    	inf.readSpace();
    	int v = inf.readInt(1, t, "v") - 1;
    	inf.readEoln();
    	ensuref(gr[u].find(v) == gr[u].end(), "Graph can not contain multiple edges");
    	gr[u].insert(v);
    }
    inf.readEof();
}