#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

vector <vector <int> > gr;
map <int, vector <int> > mp;

int mod = 1e9 + 7;
long long base = 100003;

vector <int> q;
vector <int> hashes;

int main() {
	int p, t, m;
	cin >> p >> t >> m;

	q.resize(p);
	long long w = base;
	for (int i = 0; i < p; ++i) {
		q[i] = ((i + 1) * w) % mod;
		w = (w * base) % mod;
	}

	gr.resize(t);
	hashes.assign(t, 0);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		gr[v].push_back(u);
		hashes[v] += q[u];
		if (hashes[v] > mod) {
			hashes[v] -= mod;
		}
	}
	int mn = 1e9;
	for (auto &v: gr) {
		mn = min(mn, (int)v.size());
	}
	for (int i = 0; i < t; ++i) {
		if (gr[i].size() == mn) {
			mp[hashes[i]].push_back(i);
		}
	}
	vector <int> ans;
	for (auto p: mp) {
		if (p.second.size() > ans.size()) {
			ans = p.second;
		}
	}
	cout << p - mn << " " << ans.size() << endl;
	for (int i = 0; i < ans.size(); ++i) {
		cout << ans[i] + 1 << " ";
	}
	cout << endl;
	return 0;
}