#include "testlib.h"

#include <cstring>
#include <iostream>
#include <utility>
#include <vector>
#include <set>

using namespace std;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	
	int X, Y, n;
	sscanf(argv[1], "%d", &X);
	sscanf(argv[2], "%d", &Y);
	sscanf(argv[3], "%d", &n);
	
	int x, y;
	x = sscanf(argv[1], "%d", &x);
	y = sscanf(argv[2], "%d", &y);

	cout << X << ' ' << Y << ' ' << n << '\n' << x << ' ' << y << '\n';
	vector<pair<int, int> > ps;
	if (X * Y <= 1000000) {
		for (int i = 0; i <= X; ++i)
			for (int j = 0; j <= Y; ++j)
				if (i != x && j != y)
					ps.push_back(make_pair(i, j));
	}
	else {
		set<pair<int, int> > S;
		S.insert(make_pair(x, y));
		while (S.size() < n) {
			int x0, y0;
			x0 = rnd.next(0, X);
			y0 = rnd.next(0, Y);
			S.insert(make_pair(x0, y0));
		}

		for (auto p : S)
			if (p.first != x || p.second != y)
				ps.push_back(p);
	}

	shuffle(ps.begin(), ps.end());
	for (int i = 1; i < n; ++i)
		cout << ps[i].first << ' ' << ps[i].second << "\n";

	return 0;
}